Index: /trunk/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComDataCU.cpp	(revision 331)
+++ /trunk/source/Lib/TLibCommon/TComDataCU.cpp	(revision 332)
@@ -5489,592 +5201,108 @@
   }
 
-  if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ) )
-  {
-    bTmpIsSkipped = pcTmpCU->isSkipped( uiIdx );
-    for(Int iList = 0; iList < (getSlice()->isInterB() ? 2: 1); iList ++)
-    {
-      eRefPicList = RefPicList(iList);
-      Int refId = pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx) ;
-      if( refId >= 0)
-      {
-        Int refViewIdx  = pcTmpCU->getSlice()->getRefViewId( eRefPicList, refId);
-        if (refViewIdx != m_pcSlice->getViewId()) // DCP
+  bCheckMcpDv = true; 
+  if ( xCheckSpatialNBDV( pcTmpCU, uiIdx, uiPartIdx, uiPartAddr, pDInfo, bCheckMcpDv, &cMvpDvInfo, DVFROM_LEFT, bDepthRefine ) )
+    return;
+
+
+  //// ******* Get disparity from above block ******* /////
+  pcTmpCU = getPUAbove(uiIdx, uiPartIdxRT, true, false, true);
+  if ( uiPartIdx == 1 && (eCUMode == SIZE_2NxN || eCUMode == SIZE_2NxnU || eCUMode == SIZE_2NxnD) )
+  {
+    pcTmpCU = NULL;
+  }
+
+  if (pcTmpCU && bParMerge) 
+  {
+    if (!pcTmpCU->isDiffMER(xP+nPSW-1, yP-1, xP, yP))
+    {
+      pcTmpCU = NULL;
+    }
+  }
+
+  if(pcTmpCU != NULL )
+  {
+    bCheckMcpDv = ( ( getAddr() - pcTmpCU->getAddr() ) == 0);
+    if ( xCheckSpatialNBDV( pcTmpCU, uiIdx, uiPartIdx, uiPartAddr, pDInfo, bCheckMcpDv, &cMvpDvInfo, DVFROM_ABOVE, bDepthRefine ) )
+      return;
+  }
+
+  //// ******* Get disparity from above right block ******* /////
+  pcTmpCU = getPUAboveRight(uiIdx, uiPartIdxRT, true, false, true);
+
+  if (pcTmpCU && bParMerge) 
+  {
+    if (!pcTmpCU->isDiffMER(xP+nPSW, yP-1, xP, yP))
+    {
+      pcTmpCU = NULL;
+    }
+  }
+
+  if(pcTmpCU != NULL )
+  {
+    bCheckMcpDv = ( ( getAddr() - pcTmpCU->getAddr() ) == 0);
+    if ( xCheckSpatialNBDV( pcTmpCU, uiIdx, uiPartIdx, uiPartAddr, pDInfo, bCheckMcpDv, &cMvpDvInfo, DVFROM_ABOVERIGHT, bDepthRefine ) )
+      return;
+  }
+
+
+  //// ******* Get disparity from below left block ******* /////
+  pcTmpCU = getPUBelowLeft(uiIdx, uiPartIdxLB, true, false);
+
+  if (pcTmpCU && bParMerge)
+  {
+    if (!pcTmpCU->isDiffMER(xP-1, yP+nPSH, xP, yP))
+    {
+      pcTmpCU = NULL;
+    }
+  }
+
+  if( pcTmpCU != NULL )
+  {
+    bCheckMcpDv = true; 
+    if ( xCheckSpatialNBDV( pcTmpCU, uiIdx, uiPartIdx, uiPartAddr, pDInfo, bCheckMcpDv, &cMvpDvInfo, DVFROM_LEFTBELOW, bDepthRefine ) )
+      return;
+  }
+
+
+  //// ******* Get disparity from above left block ******* /////
+  pcTmpCU = getPUAboveLeft(uiIdx, (m_uiAbsIdxInLCU + uiPartAddr), true, false, true);
+  assert(uiPartIdxLT == (m_uiAbsIdxInLCU + uiPartAddr));
+
+  if (pcTmpCU && bParMerge) 
+  {
+    if (!pcTmpCU->isDiffMER(xP-1, yP-1, xP, yP))
+    {
+      pcTmpCU = NULL;
+    }
+  }
+
+  if( pcTmpCU != NULL )
+  {
+    bCheckMcpDv = (( getAddr() - pcTmpCU->getAddr() ) <= 1); 
+    if ( xCheckSpatialNBDV( pcTmpCU, uiIdx, uiPartIdx, uiPartAddr, pDInfo, bCheckMcpDv, &cMvpDvInfo, DVFROM_ABOVELEFT, bDepthRefine ) )
+      return;
+  }
+
+  //// ******* Search MCP blocks ******* /////
+  if( cMvpDvInfo.m_bFound ) 
+  {
+    for( Int curPos = 0 ; curPos < MCP_DIS_CANS ; curPos++ ) 
+    {
+      for(Int iList = 0; iList < (getSlice()->isInterB() ? 2: 1); iList ++)
+      {
+        if( cMvpDvInfo.m_bAvailab[iList][curPos] )
         {
-          TComMv cMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
-          clipMv(cMvPred);
-#if !MERL_MTK_VSP_DVP_REFINE_C0152_C0131
-          pDInfo->m_acMvCand[ pDInfo->iN] = cMvPred; 
-          pDInfo->m_aVIdxCan[ pDInfo->iN++] = refViewIdx;
-#else
-          {
-            TComPic* picDepth = NULL;
-            picDepth = getSlice()->getRefPicBaseDepth();
-            if (picDepth && bDepthRefine)
-#if LGE_SIMP_DVP_REFINE_C0112
-              estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cMvPred, true);
-#else
-              estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cMvPred);
-#endif
-            pDInfo->m_acMvCand[ pDInfo->iN] = cMvPred;
-            pDInfo->m_aVIdxCan[ pDInfo->iN++] = refViewIdx;
-          }
-#endif
+          TComMv cDispVec = cMvpDvInfo.m_acMvCand[iList][ curPos ];
+          clipMv( cDispVec );
+
+          TComPic* picDepth = getSlice()->getRefPicBaseDepth();
+          if (picDepth && bDepthRefine)
+            estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cDispVec, true);
+
+          pDInfo->m_acMvCand[ pDInfo->iN]   = cDispVec;
+          pDInfo->m_aVIdxCan[ pDInfo->iN++] = 0;
           return;
         }
-        else // MCP 
-        {
-          cTmpMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
-          if( cTmpMvPred.m_bDvMcp && bTmpIsSkipped )
-          {
-#if MTK_RELEASE_DV_CONSTRAINT_C0129
-            aiDvMcpDvCandX[iList][DVFROM_LEFT] = cTmpMvPred.m_iDvMcpDispX;
-            aiDvMcpDvCandY[iList][DVFROM_LEFT] = cTmpMvPred.m_iDvMcpDispY;
-#else
-            aiDvMcpDvCand[iList][DVFROM_LEFT] = cTmpMvPred.m_iDvMcpDispX;
-#endif
-            abDvMcpFlag  [iList][DVFROM_LEFT] = true; 
-            bDvMcpIsFound = true;
-          }
-        }
-      }
-#if MERL_VSP_C0152
-      else if (pcTmpCU->getVSPIndex(uiIdx) != 0) // is VSP
-      {
-        TComPic* picDepth = NULL;
-        TComMv myMv = pcTmpCU->getCUMvField( eRefPicList )->getMv( uiIdx );
-        picDepth = pcTmpCU->getSlice()->getRefPicBaseDepth();
-        if (picDepth && bDepthRefine)
-          estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &myMv);
-        myMv.setVer(0);
-
-        pDInfo->m_acMvCand[ pDInfo->iN] = myMv;
-        pDInfo->m_aVIdxCan[ pDInfo->iN++] = 0; // refViewIdx;
-        return;
-      }
-#endif
-    }
-  }
-
-  pcTmpCU = getPUAbove(uiIdx, uiPartIdxRT, true, false, true);
-  if ( uiPartIdx == 1 && (eCUMode == SIZE_2NxN || eCUMode == SIZE_2NxnU || eCUMode == SIZE_2NxnD) )
-  {
-    pcTmpCU = NULL;
-  }
-
-  if (pcTmpCU && bParMerge) 
-  {
-    if (!pcTmpCU->isDiffMER(xP+nPSW-1, yP-1, xP, yP))
-    {
-      pcTmpCU = NULL;
-    }
-  }
-
-  if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ))
-  {
-    iLCUAddrDiff = getAddr() - pcTmpCU->getAddr();
-    bTmpIsSkipped = pcTmpCU->isSkipped( uiIdx );
-    for(Int iList = 0; iList < (getSlice()->isInterB() ? 2: 1); iList ++)
-    {
-      eRefPicList = RefPicList(iList);
-      Int refId = pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx) ;
-      if( refId >= 0)
-      {
-        Int refViewIdx  = pcTmpCU->getSlice()->getRefViewId( eRefPicList, refId);
-        if (refViewIdx!= m_pcSlice->getViewId())
-        {
-          TComMv cMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
-          clipMv(cMvPred);
-#if !MERL_MTK_VSP_DVP_REFINE_C0152_C0131
-          pDInfo->m_acMvCand[ pDInfo->iN] = cMvPred; 
-          pDInfo->m_aVIdxCan[ pDInfo->iN++] = refViewIdx;
-#else
-          {
-            TComPic* picDepth = NULL;
-            picDepth = getSlice()->getRefPicBaseDepth();
-            if (picDepth && bDepthRefine)
-#if LGE_SIMP_DVP_REFINE_C0112
-              estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cMvPred, true);
-#else
-              estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cMvPred);
-#endif
-            pDInfo->m_acMvCand[ pDInfo->iN] = cMvPred;
-            pDInfo->m_aVIdxCan[ pDInfo->iN++] = refViewIdx;
-          }
-#endif
-          return;
-        }
-        else if(iLCUAddrDiff == 0) //MCP, within same LCU
-        {
-          cTmpMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
-          if( cTmpMvPred.m_bDvMcp  && bTmpIsSkipped )
-          {
-#if MTK_RELEASE_DV_CONSTRAINT_C0129
-            aiDvMcpDvCandX[iList][DVFROM_ABOVE] = cTmpMvPred.m_iDvMcpDispX;
-            aiDvMcpDvCandY[iList][DVFROM_ABOVE] = cTmpMvPred.m_iDvMcpDispY;
-#else
-            aiDvMcpDvCand[iList][DVFROM_ABOVE] = cTmpMvPred.m_iDvMcpDispX;
-#endif
-            abDvMcpFlag  [iList][DVFROM_ABOVE] = true; 
-            bDvMcpIsFound = true;
-          }
-        }
-      }
-#if MERL_VSP_C0152
-      else if (pcTmpCU->getVSPIndex(uiIdx) != 0) // is VSP
-      {
-        TComPic* picDepth = NULL;
-        TComMv myMv = pcTmpCU->getCUMvField( eRefPicList )->getMv( uiIdx );
-        picDepth = pcTmpCU->getSlice()->getRefPicBaseDepth();
-        if (picDepth && bDepthRefine)
-          estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &myMv);
-        myMv.setVer(0);
-
-        pDInfo->m_acMvCand[ pDInfo->iN] = myMv;
-        pDInfo->m_aVIdxCan[ pDInfo->iN++] = 0; // refViewIdx;
-        return;
-      }
-#endif
-    }
-  }
-
-  pcTmpCU = getPUAboveRight(uiIdx, uiPartIdxRT, true, false, true);
-
-  if (pcTmpCU && bParMerge) 
-  {
-    if (!pcTmpCU->isDiffMER(xP+nPSW, yP-1, xP, yP))
-    {
-      pcTmpCU = NULL;
-    }
-  }
-
-  if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ) )
-  {
-    iLCUAddrDiff = getAddr() - pcTmpCU->getAddr();
-    bTmpIsSkipped = pcTmpCU->isSkipped( uiIdx );
-    for(Int iList = 0; iList < (getSlice()->isInterB() ? 2: 1); iList ++)
-    {
-      eRefPicList = RefPicList(iList);
-      Int refId = pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx) ;
-      if( refId >= 0)
-      {
-        Int refViewIdx  = pcTmpCU->getSlice()->getRefViewId( eRefPicList, refId);
-        if (refViewIdx!= m_pcSlice->getViewId())
-        {
-          TComMv cMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
-          clipMv(cMvPred);
-#if !MERL_MTK_VSP_DVP_REFINE_C0152_C0131
-          pDInfo->m_acMvCand[ pDInfo->iN] = cMvPred; 
-          pDInfo->m_aVIdxCan[ pDInfo->iN++] = refViewIdx;
-#else
-          {
-            TComPic* picDepth = NULL;
-            picDepth = getSlice()->getRefPicBaseDepth();
-            if (picDepth && bDepthRefine)
-#if LGE_SIMP_DVP_REFINE_C0112
-              estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cMvPred, true);
-#else
-              estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cMvPred);
-#endif
-            pDInfo->m_acMvCand[ pDInfo->iN] = cMvPred;
-            pDInfo->m_aVIdxCan[ pDInfo->iN++] = refViewIdx;
-          }
-#endif
-          return;
-        }
-        else if(iLCUAddrDiff == 0)
-        {
-          cTmpMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
-          if( cTmpMvPred.m_bDvMcp && bTmpIsSkipped )
-          {
-#if MTK_RELEASE_DV_CONSTRAINT_C0129
-            aiDvMcpDvCandX[iList][DVFROM_ABOVERIGHT] = cTmpMvPred.m_iDvMcpDispX;
-            aiDvMcpDvCandY[iList][DVFROM_ABOVERIGHT] = cTmpMvPred.m_iDvMcpDispY;
-#else
-            aiDvMcpDvCand[iList][DVFROM_ABOVERIGHT] = cTmpMvPred.m_iDvMcpDispX;
-#endif
-            abDvMcpFlag  [iList][DVFROM_ABOVERIGHT] = true; 
-            bDvMcpIsFound = true;
-          }
-        }
-      }
-#if MERL_VSP_C0152
-      else if (pcTmpCU->getVSPIndex(uiIdx) != 0) // is VSP
-      {
-        TComPic* picDepth = NULL;
-        TComMv myMv = pcTmpCU->getCUMvField( eRefPicList )->getMv( uiIdx );
-        picDepth = pcTmpCU->getSlice()->getRefPicBaseDepth();
-        if (picDepth && bDepthRefine)
-          estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &myMv);
-        myMv.setVer(0);
-
-        pDInfo->m_acMvCand[ pDInfo->iN] = myMv;
-        pDInfo->m_aVIdxCan[ pDInfo->iN++] = 0; // refViewIdx;
-        return;
-      }
-#endif
-    }
-  }
-
-  pcTmpCU = getPUBelowLeft(uiIdx, uiPartIdxLB, true, false);
-
-  if (pcTmpCU && bParMerge)
-  {
-    if (!pcTmpCU->isDiffMER(xP-1, yP+nPSH, xP, yP))
-    {
-      pcTmpCU = NULL;
-    }
-  }
-
-  if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ))
-  {
-    bTmpIsSkipped = pcTmpCU->isSkipped( uiIdx );
-    for(Int iList = 0; iList < (getSlice()->isInterB() ? 2: 1); iList ++)
-    {
-      eRefPicList = RefPicList(iList);
-      Int refId = pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx) ;
-      if( refId >= 0)
-      {
-        Int refViewIdx  = pcTmpCU->getSlice()->getRefViewId( eRefPicList, refId);
-        if (refViewIdx!= m_pcSlice->getViewId())
-        {
-          TComMv cMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
-          clipMv(cMvPred);
-#if !MERL_MTK_VSP_DVP_REFINE_C0152_C0131
-          pDInfo->m_acMvCand[ pDInfo->iN] = cMvPred; 
-          pDInfo->m_aVIdxCan[ pDInfo->iN++] = refViewIdx;
-#else
-          {
-            TComPic* picDepth = NULL;
-            picDepth = getSlice()->getRefPicBaseDepth();
-            if (picDepth && bDepthRefine)
-#if LGE_SIMP_DVP_REFINE_C0112
-              estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cMvPred, true);
-#else
-              estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cMvPred);
-#endif
-            pDInfo->m_acMvCand[ pDInfo->iN] = cMvPred;
-            pDInfo->m_aVIdxCan[ pDInfo->iN++] = refViewIdx;
-          }
-#endif
-          return;
-        }
-        else // MCP 
-        {
-          cTmpMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
-          if( cTmpMvPred.m_bDvMcp && bTmpIsSkipped )
-          {
-#if MTK_RELEASE_DV_CONSTRAINT_C0129
-            aiDvMcpDvCandX[iList][DVFROM_LEFTBELOW] = cTmpMvPred.m_iDvMcpDispX;
-            aiDvMcpDvCandY[iList][DVFROM_LEFTBELOW] = cTmpMvPred.m_iDvMcpDispY;
-#else
-            aiDvMcpDvCand[iList][DVFROM_LEFTBELOW] = cTmpMvPred.m_iDvMcpDispX;
-#endif
-            abDvMcpFlag  [iList][DVFROM_LEFTBELOW] = true; 
-            bDvMcpIsFound = true;
-          }
-        }
-      }
-#if MERL_VSP_C0152
-      else if (pcTmpCU->getVSPIndex(uiIdx) != 0) // is VSP
-      {
-        TComPic* picDepth = NULL;
-        TComMv myMv = pcTmpCU->getCUMvField( eRefPicList )->getMv( uiIdx );
-        picDepth = pcTmpCU->getSlice()->getRefPicBaseDepth();
-        if (picDepth && bDepthRefine)
-          estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &myMv);
-        myMv.setVer(0);
-
-        pDInfo->m_acMvCand[ pDInfo->iN] = myMv;
-        pDInfo->m_aVIdxCan[ pDInfo->iN++] = 0; // refViewIdx;
-        return;
-      }
-#endif
-    }
-  }
-
-  // Above predictor search
-  pcTmpCU = getPUAboveLeft(uiIdx, (m_uiAbsIdxInLCU + uiPartAddr), true, false, true);
-  assert(uiPartIdxLT == (m_uiAbsIdxInLCU + uiPartAddr));
-
-  if (pcTmpCU && bParMerge) 
-  {
-    if (!pcTmpCU->isDiffMER(xP-1, yP-1, xP, yP))
-    {
-      pcTmpCU = NULL;
-    }
-  }
-
-  if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ))
-  {
-    iLCUAddrDiff = getAddr() - pcTmpCU->getAddr();
-
-    bTmpIsSkipped = pcTmpCU->isSkipped( uiIdx );
-    for(Int iList = 0; iList < (getSlice()->isInterB() ? 2: 1); iList ++)
-    {
-      eRefPicList = RefPicList(iList);
-      Int refId = pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx) ;
-      if( refId >= 0)
-      {
-        Int refViewIdx  = pcTmpCU->getSlice()->getRefViewId( eRefPicList, refId);
-        if (refViewIdx!= m_pcSlice->getViewId())
-        {
-          TComMv cMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
-          clipMv(cMvPred);
-#if !MERL_MTK_VSP_DVP_REFINE_C0152_C0131
-          pDInfo->m_acMvCand[ pDInfo->iN] = cMvPred; 
-          pDInfo->m_aVIdxCan[ pDInfo->iN++] = refViewIdx;
-#else
-          {
-            TComPic* picDepth = NULL;
-            picDepth = getSlice()->getRefPicBaseDepth();
-            if (picDepth && bDepthRefine)
-#if LGE_SIMP_DVP_REFINE_C0112
-              estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cMvPred, true);
-#else
-              estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cMvPred);
-#endif
-            pDInfo->m_acMvCand[ pDInfo->iN] = cMvPred;
-            pDInfo->m_aVIdxCan[ pDInfo->iN++] = refViewIdx;
-          }
-#endif
-          return;
-        }
-        else if(iLCUAddrDiff <= 1)
-        {
-          cTmpMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
-          if( cTmpMvPred.m_bDvMcp && bTmpIsSkipped )
-          {
-#if MTK_RELEASE_DV_CONSTRAINT_C0129
-            aiDvMcpDvCandX[iList][DVFROM_ABOVELEFT] = cTmpMvPred.m_iDvMcpDispX;
-            aiDvMcpDvCandY[iList][DVFROM_ABOVELEFT] = cTmpMvPred.m_iDvMcpDispY;
-#else
-            aiDvMcpDvCand[iList][DVFROM_ABOVELEFT] = cTmpMvPred.m_iDvMcpDispX;
-#endif
-            abDvMcpFlag  [iList][DVFROM_ABOVELEFT] = true; 
-            bDvMcpIsFound = true;
-          }
-        }
-      }
-#if MERL_VSP_C0152
-      else if (pcTmpCU->getVSPIndex(uiIdx) != 0) // is VSP
-      {
-        TComPic* picDepth = NULL;
-        TComMv myMv = pcTmpCU->getCUMvField( eRefPicList )->getMv( uiIdx );
-        picDepth = pcTmpCU->getSlice()->getRefPicBaseDepth();
-        if (picDepth && bDepthRefine)
-          estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &myMv);
-        myMv.setVer(0);
-
-        pDInfo->m_acMvCand[ pDInfo->iN] = myMv;
-        pDInfo->m_aVIdxCan[ pDInfo->iN++] = 0; // refViewIdx;
-        return;
-      }
-#endif
-    }
-  }
-#if !MTK_SAIT_TEMPORAL_FIRST_ORDER_C0141_C0097
-  // copied from getInterMergeCand()
-  if ( getSlice()->getPPS()->getEnableTMVPFlag() )
-  {
-    TComMv cColMv;
-    Int iTargetViewIdx = 0;
-    Int iTStartViewIdx = 0;
-    UInt uiPartIdxRB, uiBRIdx;
-#if !MTK_SIMPLIFY_DVTC_C0135
-    Int uiViewIdxCurr= getSlice()->getViewId();
-#endif
-    UInt uiPartIdxCenter;
-    xDeriveCenterIdx( eCUMode, uiPartIdx, uiPartIdxCenter );
-
-    Int uiLCUIdx = getAddr();
-    Int uiLCUnew = uiLCUIdx;
-    eCUMode = getPartitionSize( 0 );
-    deriveRightBottomIdx( eCUMode, uiPartIdx, uiPartIdxRB );  
-    uiBRIdx = uiPartIdxLT;
-    UInt uiAbsPartIdxTmp = g_auiZscanToRaster[uiPartIdxRB];
-#if MTK_SIMPLIFY_DVTC_C0135
-    if (( m_pcPic->getCU(m_uiCUAddr)->getCUPelX() + g_auiRasterToPelX[uiAbsPartIdxTmp] + m_pcPic->getMinCUWidth() )>= m_pcSlice->getSPS()->getPicWidthInLumaSamples() )
-    {
-      uiLCUnew = -1;
-    }
-    else if(( m_pcPic->getCU(m_uiCUAddr)->getCUPelY() + g_auiRasterToPelY[uiAbsPartIdxTmp] + m_pcPic->getMinCUHeight() )>= m_pcSlice->getSPS()->getPicHeightInLumaSamples() )
-    {
-      uiLCUnew = -1;
-    }
-    else
-#else
-    if ( (( m_pcPic->getCU(m_uiCUAddr)->getCUPelX() + g_auiRasterToPelX[uiAbsPartIdxTmp] + m_pcPic->getMinCUWidth() ) < m_pcSlice->getSPS()->getPicWidthInLumaSamples() ) &&(( m_pcPic->getCU(m_uiCUAddr)->getCUPelY() + g_auiRasterToPelY[uiAbsPartIdxTmp] + m_pcPic->getMinCUHeight() ) < m_pcSlice->getSPS()->getPicHeightInLumaSamples() ))  // image boundary check
-#endif
-    {
-      if ( ( uiAbsPartIdxTmp % uiNumPartInCUWidth < uiNumPartInCUWidth - 1 ) &&           // is not at the last column of LCU 
-      ( uiAbsPartIdxTmp / uiNumPartInCUWidth < m_pcPic->getNumPartInHeight() - 1 ) ) // is not at the last row    of LCU
-      {
-        uiBRIdx = g_auiRasterToZscan[ uiAbsPartIdxTmp + uiNumPartInCUWidth + 1 ];
-      }
-      else if ( uiAbsPartIdxTmp % uiNumPartInCUWidth < uiNumPartInCUWidth - 1 )           // is not at the last column of LCU But is last row of LCU
-      {
-        uiBRIdx = g_auiRasterToZscan[ (uiAbsPartIdxTmp + uiNumPartInCUWidth + 1) % m_pcPic->getNumPartInCU() ];
-#if MTK_SIMPLIFY_DVTC_C0135
-        uiLCUnew = -1;
-#else
-        uiLCUnew = uiLCUIdx + m_pcPic->getFrameWidthInCU();
-#endif
-      }
-      else if ( uiAbsPartIdxTmp / uiNumPartInCUWidth < m_pcPic->getNumPartInHeight() - 1 ) // is not at the last row of LCU But is last column of LCU
-      {
-        uiBRIdx = g_auiRasterToZscan[ uiAbsPartIdxTmp + 1 ];
-        uiLCUnew = uiLCUIdx + 1;
-      }
-      else //is the right bottom corner of LCU                       
-      {
-        uiBRIdx = 0;
-#if MTK_SIMPLIFY_DVTC_C0135
-        uiLCUnew = -1;
-#else
-        uiLCUnew = uiLCUIdx + m_pcPic->getFrameWidthInCU() + 1;
-#endif
-      }
-    }
-    const Int iNumofCandPic = 2;
-    for(Int i =0; i < iNumofCandPic; i++)
-    {
-      Int lpRef=0;
-      if(i == 0)
-      {   //check the col-located picture
-        eRefPicList = RefPicList(getSlice()->isInterB() ? getSlice()->getColDir() : 0);
-#if COLLOCATED_REF_IDX
-        lpRef = getSlice()->getColRefIdx();
-#else
-        Int lpRef = 0;
-#endif
-      }
-      else
-      {
-        if(!(getPic()->getRapbCheck()))
-          break;
-        eRefPicList=getPic()->getRapRefList();
-        lpRef=getPic()->getRapRefIdx();
-      }
-
-      if( m_pcSlice->getViewId() == getSlice()->getRefPic( eRefPicList, lpRef)->getViewId() ) 
-      {
-#if !MTK_SIMPLIFY_DVTC_C0135
-        if (uiViewIdxCurr > 1)  
-        {
-#endif
-          if( (uiLCUnew >= 0 && xGetColDisMV( eRefPicList, lpRef, uiLCUnew, uiBRIdx, cColMv, iTargetViewIdx, iTStartViewIdx)) )
-          {
-            clipMv(cColMv);
-#if !MERL_MTK_VSP_DVP_REFINE_C0152_C0131
-            pDInfo->m_acMvCand[ pDInfo->iN] = cColMv;
-            pDInfo->m_aVIdxCan[ pDInfo->iN++] = iTargetViewIdx;
-#else
-            {
-              TComPic* picDepth = NULL;
-              picDepth = getSlice()->getRefPicBaseDepth();
-              if (picDepth && bDepthRefine)
-#if LGE_SIMP_DVP_REFINE_C0112
-                estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cColMv, true);
-#else
-                estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cColMv);
-#endif
-
-              pDInfo->m_acMvCand[ pDInfo->iN] = cColMv;
-              pDInfo->m_aVIdxCan[ pDInfo->iN++] = iTargetViewIdx;
-            }
-#endif
-            return ;
-          }
-#if !MTK_SIMPLIFY_DVTC_C0135
-        }
-#endif
-        if(xGetColDisMV( eRefPicList, lpRef, uiLCUIdx, uiPartIdxCenter,  cColMv, iTargetViewIdx, iTStartViewIdx ))
-        {
-          clipMv(cColMv);
-#if !MERL_MTK_VSP_DVP_REFINE_C0152_C0131
-            pDInfo->m_acMvCand[ pDInfo->iN] = cColMv;
-            pDInfo->m_aVIdxCan[ pDInfo->iN++] = iTargetViewIdx;
-#else
-            {
-              TComPic* picDepth = NULL;
-              picDepth = getSlice()->getRefPicBaseDepth();
-              if (picDepth && bDepthRefine)
-#if LGE_SIMP_DVP_REFINE_C0112
-                estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cColMv, true);
-#else
-                estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cColMv);
-#endif
-              pDInfo->m_acMvCand[ pDInfo->iN] = cColMv;
-              pDInfo->m_aVIdxCan[ pDInfo->iN++] = iTargetViewIdx;
-            }
-#endif
-          return ;
-        }
-#if !MTK_SIMPLIFY_DVTC_C0135
-        if(uiViewIdxCurr == 1)  
-        {
-          if( (uiLCUnew >= 0 && xGetColDisMV( eRefPicList, lpRef, uiLCUnew, uiBRIdx, cColMv, iTargetViewIdx, iTStartViewIdx)) ) 
-          {
-            clipMv(cColMv);
-#if !MERL_MTK_VSP_DVP_REFINE_C0152_C0131
-            pDInfo->m_acMvCand[ pDInfo->iN] = cColMv;
-            pDInfo->m_aVIdxCan[ pDInfo->iN++] = iTargetViewIdx;
-#else
-            {
-              TComPic* picDepth = NULL;
-              picDepth = getSlice()->getRefPicBaseDepth();
-              if (picDepth && bDepthRefine)
-#if LGE_SIMP_DVP_REFINE_C0112
-                estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cColMv, true);
-#else
-                estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cColMv);
-#endif
-              pDInfo->m_acMvCand[ pDInfo->iN] = cColMv;
-              pDInfo->m_aVIdxCan[ pDInfo->iN++] = iTargetViewIdx;
-            }
-#endif
-            return ;
-          }
-        }
-#endif
-      }
-    }
-  } // if TMVP Flag
-#endif
-
-  if( bDvMcpIsFound ) // skip dvmcp
-  {
-    for( Int i=1 ; i<iNumofDvMCP-1 ; i++ ) // 5 spatial
-    {
-      for(Int iList = 0; iList < (getSlice()->isInterB() ? 2: 1); iList ++)
-      {
-        if( abDvMcpFlag[iList][i]==true )
-        {
-#if MTK_RELEASE_DV_CONSTRAINT_C0129
-          TComMv dv( aiDvMcpDvCandX[iList][ i ], aiDvMcpDvCandY[iList][ i ] );
-#else
-          TComMv dv( aiDvMcpDvCand[iList][ i ], 0 );
-#endif
-          clipMv( dv );
-#if !MERL_MTK_VSP_DVP_REFINE_C0152_C0131
-          pDInfo->m_acMvCand[ pDInfo->iN] = dv;
-          pDInfo->m_aVIdxCan[ pDInfo->iN++] = 0;
-#else
-          {
-            TComPic* picDepth = NULL;
-            picDepth = getSlice()->getRefPicBaseDepth();
-            if (picDepth && bDepthRefine)
-#if LGE_SIMP_DVP_REFINE_C0112
-              estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &dv, true);
-#else
-              estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &dv);
-#endif
-            pDInfo->m_acMvCand[ pDInfo->iN] = dv;
-            pDInfo->m_aVIdxCan[ pDInfo->iN++] = 0;
-          }
-#endif
-          return;
-        }
-
       }
     }
@@ -6131,4 +5359,5 @@
 #endif
               ); 
+
 #if FCO_DVP_REFINE_C0132_C0170
       if(getPic()->getDepthCoded() )
@@ -6153,23 +5382,13 @@
         cDisInfo.m_aVIdxCan[0] = 0;
       }
-#if QC_AMVP_MRG_UNIFY_IVCAN_C0051
       Int paiPdmRefIdx[4] = {-1, -1, -1, -1};
       Int iPdmDir[4]      = {-1, -1, -1, -1};
-#if QC_C0051_FIXED_BY_MTK
       TComMv cPdmMvPred[4];
-#else
-      TComMv cPdmMvPred[2];
-#endif
       cPdmMvPred[0].m_bDvMcp = cPdmMvPred[1].m_bDvMcp = false; 
       if(getUnifiedMvPredCan(uiPartIdx, eRefPicList, iRefIdx, paiPdmRefIdx, cPdmMvPred, &cDisInfo, iPdmDir, false))
-#else // QC_AMVP_MRG_UNIFY_IVCAN_C0051
-      TComMv  cPdmMvPred;
-      if( getPdmMvPredDisCan( uiPartIdx, eRefPicList, iRefIdx, cPdmMvPred, &cDisInfo ) )
-#endif // QC_AMVP_MRG_UNIFY_IVCAN_C0051
 #else // H3D_NBDV
       if( getPdmMvPred( uiPartIdx, eRefPicList, iRefIdx, cPdmMvPred ) )
 #endif
 
-#if QC_AMVP_MRG_UNIFY_IVCAN_C0051
       {
         clipMv( cPdmMvPred[0] );
@@ -6180,14 +5399,4 @@
         pInfo->m_acMvCand[0].set(0,0);
       }
-#else
-      {
-        clipMv( cPdmMvPred );
-        pInfo->m_acMvCand[0] = cPdmMvPred;
-      }
-      else
-      {
-        pInfo->m_acMvCand[0].set(0,0);
-      }
-#endif
     }
   }
@@ -6771,5 +5980,4 @@
   iColViewIdx = pColCU->getSlice()->getViewId();
 #if MERL_VSP_C0152
-  //TComDataCU *pColCU = pColPic->getCU( uiCUAddr );
   if( pColCU->getCUMvField(eColRefPicList)->getRefIdx(uiAbsPartAddr) < 0)
   {
@@ -6786,12 +5994,5 @@
     if(pColCU->getSlice()->isInterB())
     {
-#if !QC_NBDV_LDB_FIX_C0055
-      if(ilist == 0 )
-        eColRefPicList = getSlice()->getCheckLDC() ? eRefPicList : RefPicList(1-getSlice()->getColDir());
-      else
-        eColRefPicList = getSlice()->getCheckLDC() ? (eRefPicList== REF_PIC_LIST_0? REF_PIC_LIST_1:REF_PIC_LIST_0 ): RefPicList(getSlice()->getColDir());
-#else
         eColRefPicList = RefPicList(ilist);
-#endif
     }
 
@@ -7933,5 +7134,4 @@
 }
 #else //H3D_NBDV
-#if QC_AMVP_MRG_UNIFY_IVCAN_C0051
 Bool
 TComDataCU::getUnifiedMvPredCan(UInt uiPartIdx, RefPicList eRefPicList, Int iRefIdx, Int* paiPdmRefIdx, TComMv* pacPdmMv, DisInfo* pDInfo, Int* iPdm, Bool bMerge )
@@ -7943,22 +7143,4 @@
   return false;
 }
-#else
-Int
-TComDataCU::getPdmMergeCandidateDisCan( UInt uiPartIdx, Int* paiPdmRefIdx, TComMv* pacPdmMv, DisInfo* pDInfo, Int* iPdm )
-{
-  TComDepthMapGenerator* pcDepthMapGenerator = m_pcSlice->getSPS()->getDepthMapGenerator();
-  ROFRS( pcDepthMapGenerator, 0 );
-  return pcDepthMapGenerator->getPdmMergeCandidate( this, uiPartIdx, paiPdmRefIdx, pacPdmMv, pDInfo, iPdm );
-}
-Bool
-TComDataCU::getPdmMvPredDisCan( UInt uiPartIdx, RefPicList eRefPicList, Int iRefIdx, TComMv& rcMv, DisInfo* pDInfo, Bool bMerge )
-{
-  TComDepthMapGenerator* pcDepthMapGenerator = m_pcSlice->getSPS()->getDepthMapGenerator();
-  ROFRS( pcDepthMapGenerator, false );
-  if (pDInfo->iN > 0 && pcDepthMapGenerator->getDisCanPdmMvPred(this, uiPartIdx, eRefPicList, iRefIdx, rcMv, pDInfo, bMerge )) //bug fix li
-    return true;
-  return false;
-}
-#endif
 #endif //H3D_NBDV
 
@@ -8000,5 +7182,7 @@
   else
 #endif
-  getDisMvpCandNBDV( 0, 0,  &cDisInfo, false );
+
+  getDisMvpCandNBDV( 0, 0,  &cDisInfo, false );  
+
   if( cDisInfo.iN == 0)
   {
@@ -8008,9 +7192,5 @@
   else
   {
-#if MTK_RELEASE_DV_CONSTRAINT_C0129
     Bool bAvailable = pcResidualGenerator->getResidualSamples( this, uiPartIdx, pcYuv, cDisInfo.m_acMvCand[0], bRecon );       
-#else
-    Bool bAvailable = pcResidualGenerator->getResidualSamples( this, uiPartIdx, pcYuv, cDisInfo.m_acMvCand[0].getHor(), bRecon ); 
-#endif
     m_pePartSize[0] = m_peSaved;
     return bAvailable;
Index: /trunk/source/Lib/TLibCommon/TComDataCU.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComDataCU.h	(revision 331)
+++ /trunk/source/Lib/TLibCommon/TComDataCU.h	(revision 332)
@@ -287,4 +287,6 @@
   );
 #if H3D_NBDV
+  Void          xDeriveRightBottomNbIdx( PartSize eCUMode, UInt uiPartIdx, Int &uiLCUIdxRBNb, Int &uiPartIdxRBNb );
+  Bool          xCheckSpatialNBDV( TComDataCU* pcTmpCU, UInt uiIdx, UInt uiPartIdx, UInt uiPartAddr, DisInfo* pNbDvInfo, Bool bSearchForMvpDv, McpDisInfo* paMvpDvInfo, UInt uiMvpDvPos, Bool bDepthRefine );
   Bool          xGetColDisMV( RefPicList eRefPicList, Int refidx, Int uiCUAddr, Int uiPartUnitIdx, TComMv& rcMv, Int & iTargetViewIdx, Int & iStartViewIdx );
 #endif 
@@ -533,10 +535,5 @@
   Bool          getPdmMvPred              ( UInt uiPartIdx, RefPicList eRefPicList, Int iRefIdx, TComMv& rcMv, Bool bMerge = false );
 #else //!H3D_NBDV
-#if QC_AMVP_MRG_UNIFY_IVCAN_C0051
   Bool          getUnifiedMvPredCan       ( UInt uiPartIdx, RefPicList eRefPicList, Int iRefIdx, Int* paiPdmRefIdx, TComMv* pacPdmMv, DisInfo* pDInfo, Int* iPdm, Bool bMerge );
-#else //QC_AMVP_MRG_UNIFY_IVCAN_C0051
-  Bool          getPdmMvPredDisCan        ( UInt uiPartIdx, RefPicList eRefPicList, Int iRefIdx, TComMv& rcMv, DisInfo* pDInfo, Bool bMerge = false );
-  Int           getPdmMergeCandidateDisCan( UInt uiPartIdx, Int* paiPdmRefIdx, TComMv* pacPdmMv, DisInfo* pDInfo, Int* iPdm );
-#endif //QC_AMVP_MRG_UNIFY_IVCAN_C0051
   Void          getDisMvpCand        ( UInt uiPartIdx, UInt uiPartAddr, DisInfo* pDInfo );
   Void          getDisMvpCandNBDV( UInt uiPartIdx, UInt uiPartAddr, DisInfo* pDInfo , Bool bParMerg = false
@@ -550,11 +547,6 @@
 
 #if MERL_VSP_C0152
-#if LGE_SIMP_DVP_REFINE_C0112
   Pel           getMcpFromDM(TComPicYuv* pcBaseViewDepthPicYuv, TComMv* mv, Int iBlkX, Int iBlkY, Int iWidth, Int iHeight, Int* aiShiftLUT, Int iShiftPrec, Bool bSimpleDvpRefine = false);
   Void          estimateDVFromDM(UInt uiPartIdx, TComPic* picDepth, UInt uiPartAddr, TComMv* cMvPred, Bool bSimpleDvpRefine = false);
-#else
-  Pel           getMcpFromDM(TComPicYuv* pcBaseViewDepthPicYuv, TComMv* mv, Int iBlkX, Int iBlkY, Int iWidth, Int iHeight, Int* aiShiftLUT, Int iShiftPrec);
-  Void          estimateDVFromDM(UInt uiPartIdx, TComPic* picDepth, UInt uiPartAddr, TComMv* cMvPred);
-#endif
 #endif
   Bool          getIViewOrgDepthMvPred( UInt uiPartIdx, RefPicList eRefPicList, Int iRefIdx, TComMv& rcMv );
@@ -579,12 +571,6 @@
   // member functions for accessing partition information
   // -------------------------------------------------------------------------------------------------------------------
-#if LG_RESTRICTEDRESPRED_M24766
+#if H3D_IVRP
   Void          getPartIndexAndSize( UInt uiPartIdx, UInt& ruiPartAddr, Int& riWidth, Int& riHeight, UInt uiAbsPartIdx = 0, Bool bLCU = false);
-#else
-  Void          getPartIndexAndSize   ( UInt uiPartIdx, UInt& ruiPartAddr, Int& riWidth, Int& riHeight );
-#endif
-#if LG_RESTRICTEDRESPRED_M24766 && !MTK_MDIVRP_C0138
-  Int           getResiPredMode(UInt uiPartAddr);
-  Void          getPUResiPredShift (Int *iPUPredResiShift, UInt uiAbsPartIndex);
 #endif
   UChar         getNumPartInter       ();
@@ -601,6 +587,4 @@
   Void          fillMvpCandBase       ( UInt uiPartIdx, UInt uiPartAddr, RefPicList eRefPicList, Int iRefIdx, AMVPInfo* pInfo );
   Void          fillMvpCand           ( UInt uiPartIdx, UInt uiPartAddr, RefPicList eRefPicList, Int iRefIdx, AMVPInfo* pInfo , Int iMVPIdx=-1);
-#else
-  Void          fillMvpCand           ( UInt uiPartIdx, UInt uiPartAddr, RefPicList eRefPicList, Int iRefIdx, AMVPInfo* pInfo );
 #endif
   Bool          isDiffMER             ( Int xN, Int yN, Int xP, Int yP);
@@ -831,4 +815,6 @@
   Pel           getSDCSegmentDCOffset( UInt uiSeg, UInt uiPartIdx ) { return m_apSegmentDCOffset[uiSeg][uiPartIdx]; }
   Void          setSDCSegmentDCOffset( Pel pOffset, UInt uiSeg, UInt uiPartIdx) { m_apSegmentDCOffset[uiSeg][uiPartIdx] = pOffset; }
+ 
+
 #endif
 };
